/*
 * JPA entity template
 *
 *
 * Takatuka - Template fuer JPA2 Entitaeten (inklusive Bean Validation)
 *
 * Moeglichkeiten und Einschraenkungen:
 * - Beziehungen werden abgebildet
 * -- es gibt keine 1:1 Beziehungen
 * -- N:M Beziehungen sind immer bidirektional
 * - Vererbung wird nicht unterstuetzt
 * - Support für CustomData
 */
package de.ivu.elect.business.stimmzettel.entity;

@javax.persistence.NamedQueries(
 {



       @javax.persistence.NamedQuery(
     name="STIMMZETTEL_KOPFDATUM.UK",
     query="SELECT o FROM StimmzettelKopfdatum o WHERE "

                         + "o"
                +".schluessel"
              +" = ?1"

             +" AND "         + "o"
                +".gebiet"
                +".nummer"
              +" = ?2"

             +" AND "         + "o"
                +".gebiet"
                +".gebietsart"
                +".name"
              +" = ?3"

             +" AND "         + "o"
                +".gebiet"
                +".gebietsart"
                +".mandant"
                +".nummer"
              +" = ?4"

             +" AND "         + "o"
                +".gebiet"
                +".wahl"
                +".wahlart"
                +".name"
              +" = ?5"

             +" AND "         + "o"
                +".gebiet"
                +".wahl"
                +".wahlart"
                +".mandant"
                +".nummer"
              +" = ?6"

             +" AND "         + "o"
                +".gebiet"
                +".wahl"
                +".wahltermin"
                +".nummer"
              +" = ?7"

             +" AND "         + "o"
                +".gebiet"
                +".wahl"
                +".wahltermin"
                +".wahldatum"
              +" = ?8"

             +" AND "         + "o"
                +".gebiet"
                +".wahl"
                +".wahltermin"
                +".mandant"
                +".nummer"
              +" = ?9"

             +" AND "         + "o"
                +".gebiet"
                +".wahltermin"
                +".nummer"
              +" = ?10"

             +" AND "         + "o"
                +".gebiet"
                +".wahltermin"
                +".wahldatum"
              +" = ?11"

             +" AND "         + "o"
                +".gebiet"
                +".wahltermin"
                +".mandant"
                +".nummer"
              +" = ?12"

             +" AND "         + "o"
                +".gruppe"
                +".schluessel"
              +" = ?13"

             +" AND "         + "o"
                +".gruppe"
                +".wahl"
                +".wahlart"
                +".name"
              +" = ?14"

             +" AND "         + "o"
                +".gruppe"
                +".wahl"
                +".wahlart"
                +".mandant"
                +".nummer"
              +" = ?15"

             +" AND "         + "o"
                +".gruppe"
                +".wahl"
                +".wahltermin"
                +".nummer"
              +" = ?16"

             +" AND "         + "o"
                +".gruppe"
                +".wahl"
                +".wahltermin"
                +".wahldatum"
              +" = ?17"

             +" AND "         + "o"
                +".gruppe"
                +".wahl"
                +".wahltermin"
                +".mandant"
                +".nummer"
              +" = ?18"

     ,
   hints = {
              @javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
             @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
   }


   )
   
     ,   @javax.persistence.NamedQuery(
     name="STIMMZETTEL_KOPFDATUM.ByGebiet",
     query="DELETE FROM StimmzettelKopfdatum o WHERE o.gebiet = ?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="STIMMZETTEL_KOPFDATUM.Gebiet",
     query="SELECT o FROM StimmzettelKopfdatum o WHERE o.gebiet = ?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="STIMMZETTEL_KOPFDATUM.SchluesselGebietGruppe",
     query="SELECT o FROM StimmzettelKopfdatum o WHERE o.schluessel = ?1 AND o.gebiet = ?2 AND gruppe = ?3",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="STIMMZETTEL_KOPFDATUM.SchluesselGebiet",
     query="SELECT o FROM StimmzettelKopfdatum o WHERE o.schluessel = ?1 AND o.gebiet = ?2 AND gruppe IS NULL",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="STIMMZETTEL_KOPFDATUM.Wahl",
     query="SELECT o FROM StimmzettelKopfdatum o WHERE o.gebiet.wahl=?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
     }
)
@javax.enterprise.inject.Vetoed
@javax.persistence.Entity
@javax.persistence.Table(name = "STIMMZETTEL_KOPFDATUM")
// @javax.persistence.IdClass(StimmzettelKopfdatumPK.class)
    @javax.persistence.EntityListeners(de.ivu.elect.jee.protokollierung.ProtokollEntityListener.class)
    @javax.persistence.Cacheable

public
 class StimmzettelKopfdatum
extends AbstractStimmzettelKopfdatum
  {

  private static final long serialVersionUID = 0L;


  /**
   * default constructor
   */
  public StimmzettelKopfdatum() {
    super();
  }

    /**
     * @param original
     *
     * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
     *             als Deprecated.
     */
    @Deprecated
    public StimmzettelKopfdatum(StimmzettelKopfdatum original){
      original.copyEntity(this);
    }

  /**
   * PRIMARY KEY
   */
  @javax.persistence.Id
  @javax.persistence.Column(name = "stimmzettel_kopfdatum_id")
    @javax.persistence.GeneratedValue(strategy = javax.persistence.GenerationType.TABLE, generator = "StimmzettelKopfdatum")
    @javax.persistence.TableGenerator(name = "StimmzettelKopfdatum", table = "SEQUENCES", pkColumnName = "sequence_name", pkColumnValue = "StimmzettelKopfdatum", valueColumnName = "next_val", allocationSize = 1000, initialValue = 0)
    protected java.lang.Long id;

  @Override
  public java.lang.Long getId() {
    return id;
  }

  public void setId(java.lang.Long id) {
    this.id = id;
  }

  @javax.persistence.Transient
  private transient StimmzettelKopfdatumPK pkCache;

  @Override
  public StimmzettelKopfdatumPK getPk() {
    if (pkCache==null || pkCache.getId() != id ) {
      pkCache = new StimmzettelKopfdatumPK(getId());
    }

    return pkCache;
  }

  public static <E extends StimmzettelKopfdatum> java.util.Map<StimmzettelKopfdatumPK, E> mappeNachPk(java.util.Collection<E> entities){
    java.util.Map<StimmzettelKopfdatumPK, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getPk(), entity);
    }

    return result;
  }

  public static <E extends StimmzettelKopfdatum> java.util.Map<Long, E> mappeNachId(java.util.Collection<E> entities){
    java.util.Map<Long, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getId(), entity);
    }

    return result;
  }



  /**
   * Indikator, ob sich ein Attribut oder eine UNIDIREKTIONALE n:1-Beziehungen geaendert hat
   */
  @javax.persistence.Transient
  protected boolean attributeChanged = false;

  public void setAttributeChanged() {
    attributeChanged = true;
  }

  public boolean isAttributeChanged() {
    return attributeChanged;
  }

  /**
   * Hilfsvariable fuer das Aktualisieren von Beziehungen
   */
  @javax.persistence.Transient
  protected boolean updateRelationship = false;



  public void resetAttributeChanged() {
        hasChangedSchluessel = false;
          hasChangedWert = false;
  
      hasChangedGebiet = false;
        hasChangedGruppe = false;
  


    attributeChanged = false;
  }


  /**
   * ATTRIBUTE
   */

    
      @javax.persistence.Column(name = "SCHLUESSEL", nullable = StimmzettelKopfdatumConstants.SCHLUESSEL_NULLABLE, length=StimmzettelKopfdatumConstants.SCHLUESSEL_MAX_LENGTH)
        
  protected java.lang.String schluessel =  null;

  @javax.persistence.Transient
  protected boolean hasChangedSchluessel = false;

  public boolean hasChangedSchluessel(){
    return hasChangedSchluessel;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertSchluessel = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenSchluessel;
  
  /**
   * 
   *
   * getter for STIMMZETTEL_KOPFDATUM.SCHLUESSEL
   */
    @Override   public  java.lang.String getSchluessel() {
        return schluessel;
      }

  /**
   * 
   *
   * setter for STIMMZETTEL_KOPFDATUM.SCHLUESSEL
   *
   * @param schluessel
   */
  @Override   public void setSchluessel( java.lang.String schluessel) {

       resetTkCache();
                  
                          java.lang.String schluesselInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(schluessel, StimmzettelKopfdatumConstants.SCHLUESSEL_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.schluessel
      , schluesselInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedSchluessel |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("schluessel");
      }


             if (!isSeitLadenVeraendertSchluessel) {
          isSeitLadenVeraendertSchluessel = thisAttributChanged;
         if (isSeitLadenVeraendertSchluessel){
           wertNachLadenSchluessel=this.schluessel;
         }
       }
      

       this.schluessel = schluesselInternal;

         }

        
  @javax.persistence.Column(name = "WERT", nullable = StimmzettelKopfdatumConstants.WERT_NULLABLE, length=StimmzettelKopfdatumConstants.WERT_MAX_LENGTH)
        
  protected java.lang.String wert =  null;

  @javax.persistence.Transient
  protected boolean hasChangedWert = false;

  public boolean hasChangedWert(){
    return hasChangedWert;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertWert = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenWert;
  
  /**
   * 
   *
   * getter for STIMMZETTEL_KOPFDATUM.WERT
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getWert() {
        return wert;
      }

  /**
   * 
   *
   * setter for STIMMZETTEL_KOPFDATUM.WERT
   *
   * @param wert
   */
  @Override   public void setWert(@javax.annotation.Nullable  java.lang.String wert) {

       resetTkCache();
                  
                          java.lang.String wertInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(wert, StimmzettelKopfdatumConstants.WERT_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.wert
      , wertInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedWert |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("wert");
      }


             if (!isSeitLadenVeraendertWert) {
          isSeitLadenVeraendertWert = thisAttributChanged;
         if (isSeitLadenVeraendertWert){
           wertNachLadenWert=this.wert;
         }
       }
      

       this.wert = wertInternal;

         }

    
/**
 * Beziehungen N:1 unidirektional
 */
  /**
   * Beziehung (unidirektional) zu Gebiet
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=false, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "GEBIET_ID", referencedColumnName="GEBIET_ID"))
  protected de.ivu.elect.business.gebietsbaum.entity.Gebiet gebiet;

  /**
   * 
   */
  @Override
  public void setGebiet( de.ivu.elect.business.gebietsbaum.entity.Gebiet gebiet){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.gebiet
    , gebiet);

    attributeChanged |= thisAttributChanged;

    hasChangedGebiet |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("gebiet");
    }

    this.gebiet = gebiet;
      }

  /**
   * 
   */
    @Override
  public de.ivu.elect.business.gebietsbaum.entity.Gebiet getGebiet(){
    return this.gebiet;
  }

  @javax.persistence.Transient
  protected boolean hasChangedGebiet = false;

  public boolean hasChangedGebiet(){
    return hasChangedGebiet;
  }

  /**
   * Beziehung (unidirektional) zu Gruppe
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=true, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "GRUPPE_ID", referencedColumnName="GRUPPE_ID"))
  protected de.ivu.elect.business.gruppe.entity.Gruppe gruppe;

  /**
   * 
   */
  @Override
  public void setGruppe(@javax.annotation.Nullable  de.ivu.elect.business.gruppe.entity.Gruppe gruppe){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.gruppe
    , gruppe);

    attributeChanged |= thisAttributChanged;

    hasChangedGruppe |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("gruppe");
    }

    this.gruppe = gruppe;
      }

  /**
   * 
   */
  @javax.annotation.Nullable   @Override
  public de.ivu.elect.business.gruppe.entity.Gruppe getGruppe(){
    return this.gruppe;
  }

  @javax.persistence.Transient
  protected boolean hasChangedGruppe = false;

  public boolean hasChangedGruppe(){
    return hasChangedGruppe;
  }


/**
 * Beziehungen N:1 bidirektional
 */

  /**
   * Beziehungen 1:N unidirektional (nicht unterstuetzt)
   */

  /**
   * Beziehungen 1:N bidirektional
   */

  /**
   * Beziehungen N:M bidirektional nicht selbstreferenzierend
   */


  /**
   * Beziehungen N:M bidirektional selbstreferenzierend
   */
  

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("StimmzettelKopfdatum:");
    sb.append(getId());
    sb.append(" (TK: ");
    try {
      sb.append(getTk());
    } catch (Exception e) {
      sb.append(e.getMessage());
    }
    sb.append(")");
    return sb.toString();
}



  /**
   * Kopiert alle Attribute (ausser PK und Version) und UNIDIREKTIONALE n:1-Beziehungen in uebergebene Entitaet.
   *
   * @param other
   *
   * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
   *             als Deprecated.
   */
  @Deprecated
  protected void copyEntity(StimmzettelKopfdatum other){
                             other.schluessel = this.schluessel;
                                other.wert = this.wert;
           
  other.setGebiet(this.getGebiet());
  other.setGruppe(this.getGruppe());
    if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }



    @Override
    public void copyEntityAttributesToOtherEntity(de.ivu.elect.jee.entity.Entity other) {
      if (other==null){
        return;
      }
      if (other.isInstanceOf(StimmzettelKopfdatum.class)){
        copyEntityAttributesUsingSetter((StimmzettelKopfdatum) other.castTo(StimmzettelKopfdatum.class).getEntity());
      } else {
        throw new IllegalArgumentException("Keine Instanz von StimmzettelKopfdatum: " + other);
      }
    }

  /**
  * Kopiert alle Attribute (ausser PK und Version)  in uebergebene Entitaet.
  *
  */
  public void copyEntityAttributesUsingSetter(StimmzettelKopfdatum other){
               other.setSchluessel(this.schluessel);
                  other.setWert(this.wert);
           if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }


  /**
   * Kopiert alle veränderten Attribute (ausser PK, CustomData, wenn vorhanden und Version) in uebergebene Entitaet.
   *
   */
  public void copyChangedEntityAttributesUsingSetter(StimmzettelKopfdatum other){
                       if (hasChangedSchluessel) {
        other.setSchluessel(this.schluessel);
      }
                             if (hasChangedWert) {
        other.setWert(this.wert);
      }
             }





    @javax.persistence.Transient
    private transient StimmzettelKopfdatumTK tkCache;

    protected void resetTkCache() {
        tkCache = null;
    }

    public StimmzettelKopfdatumTK getStimmzettelKopfdatumTK(){
    if (tkCache==null) {
    tkCache = new StimmzettelKopfdatumTK(

getSchluessel()
,   (getGebiet() == null) ? null : getGebiet().getGebietTK()
,   (getGruppe() == null) ? null : getGruppe().getGruppeTK()


  );}
  return tkCache;
}
    @Override
    public de.ivu.elect.jee.entity.tk.EntityTK getTk() {
       return getStimmzettelKopfdatumTK();
    }

  @Override
  public StimmzettelKopfdatumUK getUk(){
    return getStimmzettelKopfdatumUK();
  }

  @Override
  public Class< ? > getEntityClass() {
    return StimmzettelKopfdatum.class;
  }

public StimmzettelKopfdatumUK getStimmzettelKopfdatumUK(){

   return  new StimmzettelKopfdatumUK(

getSchluessel()
,     getGebiet()==null?null:getGebiet().getGebietUK()
,     getGruppe()==null?null:getGruppe().getGruppeUK()


  );
}

  @javax.persistence.Transient
  private transient StimmzettelKopfdatumProperties properties;

  public StimmzettelKopfdatumProperties getProperties(){
    if (properties == null) {
      properties = new StimmzettelKopfdatumProperties(this);
    }
    return properties;
  }

  /**
   * @deprecated getProperties() verwenden.
   */
  @Deprecated
  public StimmzettelKopfdatumProperties getStimmzettelKopfdatumProperties(){
    return getProperties();
  }

  @Override
  public String getEntityTechnicalName() {
    return StimmzettelKopfdatumConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public boolean isAenderungenProtokollieren(){
    
    return true;
  }


    @Override
   public void setProtokollierteAttributeMitWerten(java.util.Map<String, de.ivu.elect.jee.protokollierung.AttributWertVorher> werteVorher) {
     
      if (werteVorher.containsKey(StimmzettelKopfdatumConstants.MESSAGE_KEY_SCHLUESSEL_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(StimmzettelKopfdatumConstants.MESSAGE_KEY_SCHLUESSEL_EINZAHL);

        schluessel =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(StimmzettelKopfdatumConstants.MESSAGE_KEY_WERT_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(StimmzettelKopfdatumConstants.MESSAGE_KEY_WERT_EINZAHL);

        wert =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

                }

  @Override
  public java.util.Map<String, de.ivu.elect.jee.protokollierung.VorherNachherWert> getProtokollierteAttributeMitWerten() {
    java.util.Map<String,de.ivu.elect.jee.protokollierung.VorherNachherWert> result;
        result = createEmptyProtokollierteAttributeMitWertenMap();
                        if (isSeitLadenVeraendertSchluessel) {
      result.put(StimmzettelKopfdatumConstants.MESSAGE_KEY_SCHLUESSEL_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenSchluessel , schluessel));
    }
                            if (isSeitLadenVeraendertWert) {
      result.put(StimmzettelKopfdatumConstants.MESSAGE_KEY_WERT_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenWert , wert));
    }
                return result;
  }

  @Override
  public void resetProtokollierteAttribute() {
                      isSeitLadenVeraendertSchluessel = false;
      wertNachLadenSchluessel = null;
                          isSeitLadenVeraendertWert = false;
      wertNachLadenWert = null;
                   }

  @Override
  public  java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> getFachlichAbhaengigeEntitaeten(){
            java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> result = new java.util.ArrayList<>();
                            return result;
  }

        
            protected String getInitialDiscriminator() {
              return "STIMMZETTEL_KOPFDATUM";
            }

            @Override
            public boolean isInstanceOf(Class<?> clazz) {
            return clazz.isInstance(this);
            }


            @Override
            public <E> de.ivu.elect.jee.entity.EntityContainer<E> castTo(Class<E> clazz) {
                return new de.ivu.elect.jee.entity.EntityContainer<>((E)this); // EntityContainer ist notwendig, da sonst von Hibernate die Entität wieder durch ihren Proxy ersetzt wird...
            }

  public boolean isPersistent() {
    return getId() != null;
  }


   private static final String BASE_CLASS_NAME = "StimmzettelKopfdatum";
   @Override
   public String getBaseClassName() {
     return BASE_CLASS_NAME;
   }


    @Override
    public boolean equals(Object obj) {
    if (obj == null) {
    return false;
    }

    if (this==obj) {
    return true;
    }


    if (id != null) {
      try {
        return id.longValue() == ((de.ivu.elect.jee.entity.Entity) obj).getId().longValue() && BASE_CLASS_NAME.equals(((de.ivu.elect.jee.entity.Entity) obj).getBaseClassName());
      } catch (Exception ignored) {
        // do nothing
        return false;
      }
    }
   return super.equals(obj);
    }

    @Override
    public int hashCode() {

      if (id==null){
        return super.hashCode();
      }
      return id.hashCode();
    }


                            @javax.persistence.Transient
                private transient java.util.Set
            <String> dirtyProperties = null;

                protected void markDirty(String property) {
            
          }

          public java.util.Set
      <String> getDirtyProperties() {
          if (dirtyProperties==null){
          dirtyProperties = new java.util.HashSet<>();
          }
          return dirtyProperties;
          }

          public void clearDirtyProperties(){
          dirtyProperties = null;
          }
          public boolean isHibernateDirty() {
            return dirtyProperties!=null;
          }

      
                public void resetValidation() {
        
    validationResult = null;
        }

        @javax.persistence.Transient
        private transient java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validationResult;

                    public java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validateEntity() {
            if (validationResult==null) {
               validationResult  = new java.util.HashSet<>();
                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(schluessel, this, StimmzettelKopfdatumConstants.MESSAGE_KEY_SCHLUESSEL_EINZAHL, validationResult);
                                                                          de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(StimmzettelKopfdatumConstants.SCHLUESSEL_MAX_LENGTH , 1 ,  schluessel, this, StimmzettelKopfdatumConstants.MESSAGE_KEY_SCHLUESSEL_EINZAHL, validationResult);
                                                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(StimmzettelKopfdatumConstants.WERT_MAX_LENGTH ,  wert, this, StimmzettelKopfdatumConstants.MESSAGE_KEY_WERT_EINZAHL, validationResult);
                                    }
             return validationResult;
        }

            
        @javax.persistence.Transient
        protected transient java.util.Map<String, Object> transientContext;

        public java.util.Map<String, Object> getTransientContext() {
          if (transientContext == null) {
             transientContext = new java.util.HashMap<>();
          }
        return transientContext;

        }

              }
